local mod = ...



-- -- Resource: Pottery -------------------------------------------------------------------------------------
-- mod:registerEnumValue ("RESOURCE_TYPE", "RESOURCE_TYPE_POTTERY")
-- mod:registerAssetId("icons/Pottery.png", "ICON_POTTERY")

-- mod:register({
-- 	DataType = "RESOURCE",
-- 	Id = "RESOURCE_POTTERY",
-- 	ResourceName = "RESOURCE_POTTERY_NAME",
-- 	Icon = "ICON_POTTERY",
-- 	ResourceTypeList = { "RESOURCE_TYPE_POTTERY", "GOODS" },
-- 	VillagerBuyingPrice = {
-- 		Resource = "GOLD_COINS",
-- 		Quantity = 8
-- 	},
-- 	IsTradable = true,
--     DisplayInInventory = true,
-- 	DisplayInToolbar = false,
-- 	OrderId = 0
-- })



-- -- Resource: Tile -------------------------------------------------------------------------------------
-- mod:registerAssetId("icons/Tile.png", "ICON_TILE")

-- mod:register({
-- 	DataType = "RESOURCE",
-- 	Id = "RESOURCE_TILE",
-- 	ResourceName = "RESOURCE_TILE_NAME",
-- 	Icon = "ICON_TILE",
-- 	ResourceTypeList = { "RESOURCE" },
-- 	IsTradable = true,
--     DisplayInInventory = true,
-- 	DisplayInToolbar = false,
-- 	OrderId = 0
-- })



-- Building: Pottery's Kiln -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING", 
	Id = "BUILDING_BASIC_POTTER",
	Name = "BUILDING_BASIC_POTTER_NAME",
	Description = "BUILDING_BASIC_POTTER_DESC",
	BuildingType = "GENERAL",
	AssetCoreBuildingPart = "BUILDING_PART_MONUMENT_POLE",
	VillagerRequired = { Status = "NEWCOMER", Quantity = 10 },
	IsEditable = true,
	BuildingPartSetList = {
		{
			Name = "BUILDING_SET_BASIC_POTTER1_NAME",
			BuildingPartList = { 
				"BUILDING_PART_BASIC_POTTERKILN",
				"BUILDING_PART_BASIC_POTTERCART",
			}
		},
    }
})



-- Building Part: Potter's Kiln -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_BASIC_POTTERKILN",
	Name = "BUILDING_PART_BASIC_POTTERKILN_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_ASSEMBLAGE",
		ClipUnderGroundInPreview = true,
		CoreRandomBuildingPartList = { "PREFAB_BASIC_POTTERKILN" },
		MandatoryBuildingPartList = {
			{ BuildingPart = "CAMPFIRE_ON_FIRE_PART" },
			{ BuildingPart = "CAMPFIRE_ON_FIRE_PART" },
			{ BuildingPart = "CAMPFIRE_ON_FIRE_PART" },
			{ BuildingPart = "CAMPFIRE_ON_FIRE_PART" },
			{ BuildingPart = "CAMPFIRE_ON_FIRE_PART" },
		}
	},
	BuildingZone = { 
		ZoneEntryList = {
			{ 
				Polygon = polygon.createCircle( 3, {0, 0}, 10 ),
				Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
			},
			{ 
				Polygon = polygon.createCircle( 2, {0, 0}, 10 ),
				Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true } 
			},
		}
	},
	AssetBuildingFunction = "BUILDING_FUNCTION_ASSIGNABLE_BASIC_POTTER",
	Cost = {
        BuildRightTaxes = {	{ Resource = "GOLD_COINS", Quantity = 5 } },
        UpkeepCost = { { Resource = "GOLD_COINS", Quantity = 1 } },
        RessourcesNeeded = {
            { Resource = "RESOURCE_CLAY", Quantity = 20 },
            { Resource = "WOOD", Quantity = 10 },
		}
	}
})



-- Building Part: Pottery Cart -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_BASIC_POTTERCART",
	Name = "BUILDING_PART_BASIC_POTTERCART_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_BASIC_POTTERCART"
	},
	BuildingZone = { 
		ZoneEntryList = {
			{ 
				Polygon = polygon.createRectangle( {1, 1}, {0, 0} ),
				Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } 
			}
		}
	},
	AssetBuildingFunction = "BUILDING_FUNCTION_BASIC_POTTERCART",
	Cost = {
        RessourcesNeeded = {
            { Resource = "PLANK", Quantity = 2 },
		}
	},
	DesirabilityModifiers = { {
		Desirability = "DESIRABILITY_RESIDENTIAL",
		Type = "ADD",
		Radius = 25.0,
		Value = 0.5
	} } 
})



-- Job: Potter -------------------------------------------------------------------------------------
mod:register({
	DataType = "JOB",
	Id = "JOB_BASIC_POTTER",
	JobName = "JOB_BASIC_POTTER_NAME",
	JobDescription = "JOB_BASIC_POTTER_DESC",
	IsLockedByDefault = false,
	DefaultBehavior = "BEHAVIOR_WORK",
	UseWorkplaceBehavior = true,
    ProductionDelay = 30.0, -- default 30
	AssetJobProgression = "DEFAULT_JOB_PROGRESSION",
	CharacterSetup = {
		DataType = "CHARACTER_SETUP", 
		RightHandObject = {
			DataType = "HAND_OBJECT",
			Model = "PREFAB_TOOL_COAL_BURNER_SHOVEL"
		},
		WalkAnimation = "WALKING",
		IdleAnimation = "OVEN"
	}
})

mod:override({
    Id = "NEWCOMER",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_BASIC_POTTER"
    }
})

mod:override({
    Id = "SERF",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_BASIC_POTTER"
    }
})

mod:override({
    Id = "COMMONER",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_BASIC_POTTER"
    }
})



-- Building Function: Pottery (Wood + Clay) -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "BUILDING_FUNCTION_BASIC_POTTERKILN1",
	Name = "BUILDING_FUNCTION_BASIC_POTTERKILN1_NAME",
	IsPrivate = false,
    WorkerCapacity = 2,
    RelatedJob = { 
        Job = "JOB_BASIC_POTTER", 
        Behavior = "BEHAVIOR_WORK"
	},
	InputInventoryCapacity = {
		{ Resource = "RESOURCE_CLAY", Quantity = 20 },
		{ Resource = "WOOD", Quantity = 20 },
	},
    ResourceListNeeded = {
		{ Resource = "RESOURCE_CLAY", Quantity = 1 },
		{ Resource = "WOOD", Quantity = 2 },
	},
	ResourceProduced = {
		{ Resource = "RESOURCE_POTTERY", Quantity = 1 },
	}
})



-- Building Function: Pottery (Coal + Clay) -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "BUILDING_FUNCTION_BASIC_POTTERKILN2",
	Name = "BUILDING_FUNCTION_BASIC_POTTERKILN2_NAME",
	IsPrivate = false,
    WorkerCapacity = 2,
    RelatedJob = { 
        Job = "JOB_BASIC_POTTER", 
        Behavior = "BEHAVIOR_WORK"
	},
	InputInventoryCapacity = {
		{ Resource = "RESOURCE_CLAY", Quantity = 20 },
		{ Resource = "COAL", Quantity = 20 },
	},
    ResourceListNeeded = {
		{ Resource = "RESOURCE_CLAY", Quantity = 1 },
		{ Resource = "COAL", Quantity = 1 },
	},
	ResourceProduced = {
		{ Resource = "RESOURCE_POTTERY", Quantity = 1 },
	}
})



-- Building Function: Tile (Wood + Clay) -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "BUILDING_FUNCTION_BASIC_POTTERKILN3",
	Name = "BUILDING_FUNCTION_BASIC_POTTERKILN3_NAME",
	IsPrivate = false,
    WorkerCapacity = 2,
    RelatedJob = { 
        Job = "JOB_BASIC_POTTER", 
        Behavior = "BEHAVIOR_WORK"
	},
	InputInventoryCapacity = {
		{ Resource = "RESOURCE_CLAY", Quantity = 20 },
		{ Resource = "WOOD", Quantity = 20 },
	},
    ResourceListNeeded = {
		{ Resource = "RESOURCE_CLAY", Quantity = 1 },
		{ Resource = "WOOD", Quantity = 2 },
	},
	ResourceProduced = {
		{ Resource = "RESOURCE_TILE", Quantity = 1 },
	}
})



-- Building Function: Tile (Coal + Clay) -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "BUILDING_FUNCTION_BASIC_POTTERKILN4",
	Name = "BUILDING_FUNCTION_BASIC_POTTERKILN4_NAME",
	IsPrivate = false,
    WorkerCapacity = 2,
    RelatedJob = { 
        Job = "JOB_BASIC_POTTER", 
        Behavior = "BEHAVIOR_WORK"
	},
	InputInventoryCapacity = {
		{ Resource = "RESOURCE_CLAY", Quantity = 20 },
		{ Resource = "COAL", Quantity = 20 },
	},
    ResourceListNeeded = {
		{ Resource = "RESOURCE_CLAY", Quantity = 1 },
		{ Resource = "COAL", Quantity = 1 },
	},
	ResourceProduced = {
		{ Resource = "RESOURCE_TILE", Quantity = 1 },
	}
})



-- Building Function Assignable: Potter's Kiln -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_ASSIGNABLE",
    Id = "BUILDING_FUNCTION_ASSIGNABLE_BASIC_POTTER",
    AuthorizedFunctionList = "BUILDING_FUNCTION_LIST_BASIC_POTTER"
})

mod:register({
    DataType = "BUILDING_FUNCTION_LIST",
    Id = "BUILDING_FUNCTION_LIST_BASIC_POTTER",
    AssetFunctionList = {
        "BUILDING_FUNCTION_BASIC_POTTERKILN1",
        "BUILDING_FUNCTION_BASIC_POTTERKILN2",
        "BUILDING_FUNCTION_BASIC_POTTERKILN3",
        "BUILDING_FUNCTION_BASIC_POTTERKILN4",
    }
})



-- Building Function: Pottery Cart -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_MARKET",
    Id = "BUILDING_FUNCTION_BASIC_POTTERCART",
    Name = "BUILDING_FUNCTION_BASIC_POTTERCART_NAME",
    WorkerCapacity = 1,
    RelatedJob = { 
        Job = "MARKET_TENDER", 
        Behavior = "BEHAVIOR_WORK"
    },
	TypeList = { "RESOURCE_TYPE_POTTERY" },
	IsOverrideCapacity = true,
	CapacityPerSlot = 50,
	InputInventoryCapacity = {
		{ Resource = "RESOURCE_POTTERY", Quantity = 25 },
	},
    ResourceListNeeded = {
		{ Resource = "RESOURCE_POTTERY", Quantity = 10 },
	},
	ResourceProduced = {
		{ Resource = "RESOURCE_POTTERY", Quantity = 10 },
	}
})
